function Units_set() {
	var selectorId = "unitSelector";
	var selector = $(selectorId);
	
	Units_makeUnitSelector();

	var unitsPref = prefs.getUnits();
	document.getElementById('temperature').style.fontSize = (unitsPref == 2 ? "30" : "45") + "px";
	Widget_changeHighSize(unitsPref == 2 ? "16" : "20");
}

function Units_makeUnitSelector() {
	var selectorId = "unitSelector";
	var selector = $(selectorId);
	
	var select = document.createElement('select');
	select.setAttribute("id",selectorId);
	
	var unitsArray = [
		{"name":"&deg;F", "value": 0},
		{"name":"&deg;C", "value": 1},
		{"name":"Both",	  "value": 2}
	];
	
	var option;
	for (var i = 0; i < unitsArray.length; i++) {
		option = document.createElement('option');
		option.setAttribute('value',unitsArray[i].value);
		option.innerHTML = unitsArray[i].name;
		if (unitsArray[i].value == prefs.getUnits()) option.selected = true;
		select.appendChild(option);
	}
	
	//change the select to what we want
	selector.parentNode.replaceChild(select,selector);

	//call new element again, addEventHandler
	selector = $(selectorId);
	
	addEvent(selector,"change",Units_update);
}

function Units_update() {
	var selectorId = "unitSelector";
	var selector = $(selectorId);

	var unitsPref = selector.options[selector.selectedIndex].value;
	prefs.setUnits(unitsPref);
	
	document.getElementById('temperature').style.fontSize = (unitsPref == 2 ? "30" : "45") + "px";
	Widget_changeHighSize(unitsPref == 2 ? "16" : "20");
	
	//update the conditions in our selected units
	Widget_launchLocalStns2();
	if (Forecast_forecastData != null) setForecast(Forecast_forecastData);
}