var loc;
var stations;
var nearestAirportId;
var locationsList;
var Query_hadVagueLocation;
var Query_dividerIndex;
var Query_TIMEOUT = 10000;

function Query_retrieve(qry, inputUrl, error_loading) {
  var url = Query_createURL(qry, inputUrl);
  var Query_url = "http://api.wunderground.com/auto/wui/geo/GeoLookupXML"+url;
  var hasBeenLoaded = false;

  if (!url) {if (error_loading) error_loading(); debug.error("Query_retrieve: bad query"); return false;}

  Query_hadVagueLocation = false;
	show('loading_back');
	Prefs_showOnly(null);
	done_button.setCancel();

  var request = newXMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  request.open("GET", Query_url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Query_TIMEOUT);   
  
  request.send();

  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
	  hasBeenLoaded = true;
	  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
			debug.trace("Query_parseData loaded");
      Query_parseData(request.responseXML, url, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      } 
    }
  }
}
function Query_createURL(qry, inputUrl) {
	var url;
	if (qry) url = "/index.xml?query="+escape(qry);
	else url = inputUrl;
	return url;
}

function Query_parseData(xml, url, error_loading) {
	
	try {
	var locationsXML;
	
	var type;
	var locNode;
	
	var locationsXML = findChild(xml,'locations');
	
	if (findChild(xml,"wui_error") != null || findChild(xml,"parseerror")) {
		
		if (error_loading) error_loading();
			
	} else if (locationsXML != null) {
		//means we have a vague case, have the user decide which location is the right one

		Query_hadVagueLocation = true;
		hide('loading_back');
		locations = findChildList(locationsXML,"location");
		Query_showVagueLocations(locations);
		
	} else if (xml != null) {
		
		loc = new Object();	
		var locNode = xml.firstChild;
    var niceUrl = findChildData(locNode,"requesturl");
    prefs.setNiceUrl(niceUrl);
		prefs.setUrl(url);	
		var city = findChildData(locNode,"city");
		prefs.setLocation(city);
		loc.city = city;
		loc.state = findChildData(locNode,"state");
		loc.country = findChildData(locNode,"country");
		loc.wuiurl = findChildData(locNode,"wuiurl");
		prefs.setLoc(loc);
		
		//store radar
		var radar = findChild(locNode,"radar");
		loc.radar = new Object();
		if (radar != null) {
			loc.radar.image = findChildData(radar,"image_url");
			loc.radar.url = findChildData(radar,"url");
			if (loc.radar.image != null) {
				loc.radar.image = loc.radar.image + "%26num=5%26width="+RADAR_DIM+"%26height="+RADAR_DIM+"&width="+RADAR_DIM+"&height="+RADAR_DIM;
			}
		}
		
		//store webcams
		loc.webcams = new Array();
		var webcamNode = findChild(locNode,"webcams");
		if (webcamNode != null) {
			var cams = webcamNode.getElementsByTagName('cam');
			if (cams) {for (var i = 0; i < cams.length; i++) {
				var webcam = new Object();
				webcam.url = findChildData(cams.item(i),"WIDGETCURRENTIMAGEURL");
				if (webcam.url) webcam.url = webcam.url + "&time=" + now();
				webcam.camUrl = findChildData(cams.item(i),"CAMURL");
				webcam.city = findChildData(cams.item(i),"city");
				webcam.state = findChildData(cams.item(i),"state");
				webcam.country = findChildData(cams.item(i),"country");
				webcam.organization = findChildData(cams.item(i),"organization");
				webcam.handle = findChildData(cams.item(i),"handle");
				loc.webcams.push(webcam);
			}}
		}
		
		prefs.setLoc(loc);
		//set the UI elements for webcams and radar
		setWebcamsAndRadar(loc);
		//get local wx station information
		var lat = findChildData(locNode,"lat");
		var lon = findChildData(locNode,"lon");
		var nearby_stations = findChild(locNode,"nearby_weather_stations");

		//FORECAST DATA
		Forecast_retrieve(setForecast, Forecast_errorLoading);
		
		//load alert data
		Alert_retrieve(setAlert,Alert_errorLoading);

		Query_parseLocalWxStns(nearby_stations,lat,lon);		
			
	} else { //probably a connection problem
		Query_connectionProblem();
	}
	} catch(e) {
		debug.error("Query_parseData: " + e.message);
		Query_connectionProblem();
	}
}

//if there are multiple locations from the input
function Query_showVagueLocations (locs) {

	locationsList = new Array();
	for (var i = 0; i < locs.length; i++) {
		locationObj = {	"name":findChildData(locs[i],"name"), 
						"type": locs[i].getAttribute("type").toLowerCase(),
						"value":findChildData(locs[i],"link")
						};
		locationsList.push(locationObj);
	}
	
	locationsList.unshift({"name":"Select a location","value":null,"disabled":true,"selected":true});
	
	makeSelectBox("vagueLocationSelect",locationsList,Query_locationVagueOnChange);
	
	Prefs_showOnly(['vagueLocationLabel','vagueLocationSelect']);
	$('vagueLocationSelect').focus();
	
	done_button.setCancel();
}

function Query_locationVagueOnChange () {
	
	var selected = $("vagueLocationSelect").selectedIndex;
	
	$('zip').value = query = locationsList[selected].name;
	prefs.setQuery(query);
	var url = locationsList[selected].value;
	delete locationsList;
	
	Query_retrieve(null,url,Query_errorLoading);
}

function Query_connectionProblem () {
	debug.error("Query_connectionProblem: connection problem");
	hide('loading_back');
	Prefs_showOnly('connectionProblem');
	done_button.reset();
}

function Query_errorLoading () {
	debug.error("Query_errorLoading: loading error");
	hide('loading_back');
	Prefs_showOnly('locationNotFound');
	done_button.setCancel();
}


function Query_parseLocalWxStns (nearby_weather_stations,lat1,lon1) {
	var airport;
	var pws;
	var stationsNode;
	var pwsNode;
	var station;
	var lat2; var lon2;
	var distance_km; var distance_mi;
	
	try {
	airport = findChild(nearby_weather_stations,"airport");
	pws = findChild(nearby_weather_stations,"pws");

	stations = new Array();
	
	//airports
	stationsNode = findChildList(airport,"station");
	
	for (var i = 0; i < stationsNode.length; i++) {
		lat2 = findChildData(stationsNode[i],"lat");
		lon2 = findChildData(stationsNode[i],"lon");
		distance_km = getDistance(lat1,lon1,lat2,lon2);
		distance_mi = distance_km / 1.609344;
		
		station = {
			"neighborhood": null,
			"city"		: findChildData(stationsNode[i],"city"),
			"state"  	: findChildData(stationsNode[i],"state"),
			"country"  	: findChildData(stationsNode[i],"country"),			
			"type"		: "airport",
			"distance_km": distance_km, //round to 2 decimal places
			"distance_mi": distance_mi,
			"id"  		: findChildData(stationsNode[i],"icao")						
		};
		stations.push(station);	
	}
	//load the nearest icao station so we can get the conditions icon
	if (stations.length && stations.length > 0) {
		nearestAirportId = stations[0].id;
		prefs.setSubLocation(outputLocalWxStnTitle(stations[0]));
		
		prefs.setAirportId(stations[0].id);
		prefs.setPWSId(null);
		done_button.eventClick(Widget_useDefaultAirport);
	}
	
	Query_dividerIndex = stations.length;
	
	//PWS
	pwsNode = findChildList(pws,"station");
	for (var i = 0; i < pwsNode.length; i++) {
		station = {
			"neighborhood": findChildData(pwsNode[i],"neighborhood"),
			"city"		: findChildData(pwsNode[i],"city"),
			"state"  	: findChildData(pwsNode[i],"state"),
			"country"  	: findChildData(pwsNode[i],"country"),			
			"type"		:"pws",
			"distance_mi": findChildData(pwsNode[i],"distance_mi"),
			"distance_km": findChildData(pwsNode[i],"distance_km"),
			"id"  		: findChildData(pwsNode[i],"id")						
		};
		stations.push(station);	
	}

	hide('loading_back');
	
	if (stations.length == 0) { //no local stations at all
		
		//load the forecast ICAO as the default localWxStn
		Prefs_showOnly(null);
		prefs.setSubLocation('');
		prefs.setPWSId(null);
		prefs.setAirportId(null);
		done_button.reset();
		
    setCurConds(new Object(),false,'none');
	  document.getElementById('wxIconOverlay').src = ICON_DIR + ICON_BLANK + ICON_FILE_TYPE;
  	document.getElementById('wxIcon').src = ICON_DIR + ICON_BLANK + ICON_FILE_TYPE;
		
	} else if (stations.length == 1) {//no choice, use the only station present

		Prefs_showOnly(null);
		if (stations[0].type == "airport") {
			prefs.setAirportId(stations[0].id);
			prefs.setPWSId(null);
		} else {
			prefs.setAirportId(null);
			prefs.setPWSId(stations[0].id);
		}
		prefs.setSubLocation(outputLocalWxStnTitle(stations[0]));
		done_button.reset();
		
		if (stations[0].type == 'airport') {
			CurCond_retrieve('airport',false,setCurConds, CurCond_errorLoading);
		} else if (stations[0].type == 'pws'){
			CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading);
		}

	} else { //multiple local wx stations
		
		done_button.setText("Done");
		Query_showLocalWxStns();		
		
	}
	} catch(e) {
		debug.error("Query_parseLocalWxStns: "+e.message);
	}

}

function Query_showLocalWxStns () {
	
	var units = prefs.getUnits();
	var name;
	var distance;
	var stations_sorted;
	var stn;
	var select_entry;
	var select_entries = new Array();
	
	select_entries.push({"name":"Airports","value":null,"optgroup":true,"selected":true});

	stations_sorted = stations;
  // stations_sorted.sort(sortByDistance);

	for(var i = 0; i < stations_sorted.length; i++) {
	  if (Query_dividerIndex == i) select_entries.push({"name":"Personal Weather Stations","value":null,"optgroup":true,"selected":false});
		stn = stations_sorted[i];
		
		name = outputLocalWxStnTitle(stn);
		distance = Math.round(units == 0 ? stn.distance_mi : stn.distance_km);

		if (distance > 0)
			name += " [" + distance + (units == 0?" mi":" km") + "]";
		
		select_entry = {
			"name"		: name,
			"value"		: i
		};
		select_entries.push(select_entry);
	}
	
	var localSelect = $('localWxStationSelect');
	var localSelectLabel = $('localWxStationLabel');
	
	makeSelectBox('localWxStationSelect',select_entries,Query_LocalWxStnsOnChange);
	
	if (Query_hadVagueLocation == true) {

		put($('localWxStationSelect'),20,110);
		put($('localWxStationLabel'),20,95);
		$('vagueLocationSelect').disabled = true;
		$('vagueLocationLabel').style.color = "#aaa";
		Prefs_showOnly(['localWxStationSelect','localWxStationLabel','vagueLocationSelect','vagueLocationLabel']);
		
	} else {
		put($('localWxStationSelect'),20,65);
		put($('localWxStationLabel'),20,50);		
		$('vagueLocationSelect').disabled = false;
		$('vagueLocationLabel').style.color = "#fff";
		Prefs_showOnly(['localWxStationSelect','localWxStationLabel']);
	}

	localSelect.focus();
}

function Query_LocalWxStnsOnChange () {
	
	var selected = $('localWxStationSelect').selectedIndex;
		
		done_button.reset();
	
		//save this information
		if (stations[selected].type == "airport") {

			prefs.setAirportId(stations[selected].id);
			prefs.setPWSId(null);
		
			CurCond_retrieve('airport',false,setCurConds, CurCond_errorLoading);
		
		} else {
		
			prefs.setAirportId(nearestAirportId);
			prefs.setPWSId(stations[selected].id);

			CurCond_retrieve('airport',true,setCurConds, CurCond_errorLoading); //true so we don't overwrite pws data (only loads icon)
			CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading); 
			
		}
		prefs.setSubLocation(outputLocalWxStnTitle(stations[selected]));
		
}