var minimizer;
var mover;
var savedX;
var savedY;
var query;
var view = window; //use so our data functions work universally

var debug = new Debug();

var Widget_VERSION = 1.42;
var Widget_upgradeAlert;

function Widget_setup() {

	if (window.widget) {
	    widget.onhide = onhide;
	    widget.onshow = onshow;
		//load preferences
		prefs = new Preferences();
	} else {
		prefs = new TESTPreferences();
	}
	
	//load units box
	Units_set();
	
	//load default photos state
	Photos_resetPhotos();
	Photos_makeFeedSelectBox();
	
	//Load UI elements
	loadStretcher();
		
	//place our saved location into the back box	
	Widget_resetZipField();

	//run the initial code if 
	if (!prefs.getUrl()) {
		
		Widget_firstLoad();
		
	} else {
			
		Widget_loadInterface();
		
		loc = prefs.getLoc();
		setWebcamsAndRadar(loc);
    if (prefs.getWebcam()) {
      selected = prefs.getWebcam();
      Widget_changeWebcam(null,selected);
      $('wundercamSelect').options[selected].selected = true;
    }

		Forecast_retrieve(Widget_launchLocalStns2, Forecast_errorLoading);
		
		Alert_retrieve(setAlert,Alert_errorLoading);
		

	}
}

function Widget_loadInterface() {
	$('location').innerHTML = prefs.getLocation();
	$('sub-location').innerHTML = prefs.getSubLocation();
	$('zip').value = prefs.getQuery();
	
	if (prefs.getDrawerState() == "photos") {
		Widget_drawerSetContent('photos',null,true);
	}
	
	if (prefs.getDrawerStateOpen() == 'closed') {
		if (window.widget) window.resizeTo(_defaultX,_defaultY);
	} else {
	  if (window.widget) window.resizeTo(_drawerX,_drawerY);
	  stretcher.stretch();
	}

	if (prefs.getWidgetState() == 'minimized')
		Widget_quickResize();
	
  var rightContent = prefs.getRightContentState();
  Widget_rightSetContent(rightContent,true);  
}

function Widget_quickResize() {
	$('middle').style.height = "0";
	put($('alertMessage'),8,42); put($('alert_background'),-2,42);	put($('infoButton'),300,47);
  hide('forecast');hide('big_drawer');
  hide('forecast-background');
	hide('radarTab'); hide('conditionsTab');
	hide('right-content'); hide('bottom-tabs');
	$('wundercamTab').style.display = "none";
	$('radarTab').style.display = "none";
	$('conditionsTab').style.display = "none";
	show('maximize');	show('minimized_forecast');
  Widget_loadMinimizer();
  minimizer.maxPosition = minimizer.positionTo = 78;
  minimizer.minPosition = minimizer.positionFrom = 0;
	if (window.widget) {
		savedX = window.innerWidth; savedY = window.innerHeight;
		window.resizeTo(_miniX,_miniY);
	}
}

function Widget_firstLoad() {
	
	//load location and stations variables
	loc = {"city":"San Francisco","state":"CA","country":"US","wuiurl":"http://www.wunderground.com/US/CA/San_Francisco.html","radar":{"image":"http://resize.wunderground.com/cgi-bin/resize_convert?ox=gif&url=radblast/cgi-bin/radar/WUNIDS_composite%3Fcenterlat=37.77500916%26centerlon=-122.41825867%26radius=15%26newmaps=1%26smooth=1%26num=5%26width=130%26height=130&width=130&height=130","url":"http://www.wunderground.com/radar/radblast.asp?ID=MUX&region=c1&lat=37.77500916&lon=-122.41825867"},"webcams":[{"url":"http://icons.wunderground.com/webcamramdisk/w/u/WunderYakuza/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/WunderYakuza/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":"The Weather Underground","handle":"WunderYakuza"},{"url":"http://icons.wunderground.com/webcamramdisk/a/d/admin/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/admin/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"admin"},{"url":"http://icons.wunderground.com/webcamramdisk/c/h/Chris/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/Chris/1/show.html","city":"Healdsburg","state":"CA","country":"US","organization":"Weather Underground","handle":"Chris"},{"url":"http://icons.wunderground.com/webcamramdisk/s/f/sfweather/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/sfweather/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"sfweather"}]};
	
	prefs.setLoc(loc);
	
	prefs.setUnits(0);
	stretcherState = 'closed';
	
	$('zip').value = query = "San Francisco, CA";
	prefs.setQuery("San Francisco, CA");
	prefs.setLocation("San Francisco");
	prefs.setSubLocation("China Basin Landing");
	prefs.setPWSId("KCASANFR14");
	prefs.setAirportId("KSFO");
	prefs.setDrawerState('forecast');
	prefs.setDrawerStateOpen('closed');
	prefs.setWidgetState('normal');
	prefs.setRightContentState('conditions');
	
	setWebcamsAndRadar(loc);
	
	var url = "/US/CA/San_Francisco.html";
	prefs.setUrl(url);
	prefs.setNiceUrl(url);
	
	Forecast_retrieve(Widget_launchLocalStns, Forecast_errorLoading);
	
	//reload Alert data
	Alert_retrieve(setAlert,Alert_errorLoading);
	
	//load other data
}

function Widget_launchLocalStns2(forecast) {
	if (forecast) setForecast(forecast);
	
	var airportId = prefs.getAirportId(); 
	var pwsId = prefs.getPWSId();
	
	if (pwsId && airportId)  {
		CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading); 
		CurCond_retrieve('airport',true,setCurConds, CurCond_errorLoading); 

	} else if (airportId) {
		CurCond_retrieve('airport',false,setCurConds, CurCond_errorLoading); 

	} else if (pwsId) {
		CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading); 			
	}
}

function Widget_launchLocalStns(forecast) {
	setForecast(forecast);
	
	CurCond_retrieve('airport',true, setCurConds, CurCond_errorLoading);
	CurCond_retrieve('pws',false, setCurConds, CurCond_errorLoading); 
}

function onhide() {
	  setAlertDisplay("none");
	  Widget_setRadarDisplay("none");
	  Timeout_pauseTimeouts();
}
function onshow() {
	if (alert_displayed == true) setAlertDisplay("");
  Widget_setRadarDisplay("");
	Timeout_resumeTimeouts();
}

function Widget_loadMinimizer() {
	minimizer = new Stretcher($('middle'),-78, 350, null);
}

function minimize() {
	if (!minimizer) Widget_loadMinimizer();
	prefs.setWidgetState('minimized');
	hide('forecast');hide('big_drawer');hide('infoButton');hide('alertMessage'); hide('alert_background');
	var fader = new Fader($('forecast-background','radarTab','conditionsTab','right-content','bottom-tabs'),minimize_1,150);
	fader.fadeOut();
}
function minimize_1() {
	hide('forecast-background');hide('right-content'); hide('bottom-tabs');
	$('wundercamTab').style.display = "none";
	$('radarTab').style.display = "none";
	$('conditionsTab').style.display = "none";
	minimizer.onFinished = minimize_2;
	minimizer.stretch();
}
function minimize_2() {
	var fader = new Fader($('maximize','minimized_forecast'),null,150);
	show('maximize');
	fader.fadeIn(); 
	show('minimized_forecast');
	put($('alertMessage'),8,42); put($('alert_background'),-2,42);	put($('infoButton'),300,47);
	show('alertMessage'); show('alert_background');	show('infoButton');
	if (window.widget) {
		savedX = window.innerWidth; savedY = window.innerHeight;
		window.resizeTo(_miniX,_miniY);
	}
}

function maximize() {
	if (window.widget) window.resizeTo(savedX,savedY);
	prefs.setWidgetState('normal');
	hide('maximize'); hide('minimized_forecast'); hide('infoButton'); hide('alertMessage');	hide('alert_background');
	minimizer.onFinished = maximize_1;
	minimizer.stretch();
}
function maximize_1() {
	minimizer.onFinished = null;
	show('forecast-background'); show('right-content'); show('bottom-tabs');
	$('radarTab').style.display = "";
	$('conditionsTab').style.display = "";
	fader = new Fader($('forecast-background','radarTab','conditionsTab','right-content','bottom-tabs'),maximize_2,150);
	fader.fadeIn();
	$('wundercamTab').style.display = "";
}
function maximize_2() {
	 delete fader;
	show('big_drawer');	show('forecast'); put($('infoButton'),302,124); show('infoButton');
	put($('alertMessage'),0,114); put($('alert_background'),-10,114);
	show('alertMessage'); show('alert_background');
}

function showPrefs()
{
	stretcher.onFinished = null;
	
    var front = $("front-panel");
    var back = $("back-panel");

    if (window.widget) {
		window.resizeTo(_backX,_backY);
        widget.prepareForTransition("ToBack");
	}
 
    front.style.display="none";
    back.style.display="block";
     
    if (window.widget) {
        setTimeout ('widget.performTransition();', stretcherState == 'open' ? STRETCH_DURATION : 0);
	}
}

function hidePrefs()
{
	if (prefs.getQuery() != $('zip').value) {
		Widget_submitLocation();
	}
	
    var front = $("front-panel");
    var back = $("back-panel");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
	}
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
	}
	
	if (stretcherState == 'open') {
		setTimeout('showBottom();',600);
	} else {
		if (window.widget) setTimeout('window.resizeTo(_drawerX,_drawerY);',0);
	}
	
	stretcherState = null;
}

function Widget_resetZipField() {
	$('zip').value = query ? query :"";
	Prefs_showOnly(null);
	done_button.reset();
}
function Widget_useDefaultAirport() {
	CurCond_retrieve('airport',false,setCurConds, CurCond_errorLoading);
	hidePrefs();
	done_button.reset();
}
function Widget_keypressSubmitLocation(evt) {
	if ((evt.charCode == 13 || evt.charCode == 3) || (evt.keyCode != null && evt.keyCode == 13))  {
		Widget_submitLocation();
	}
}
function Widget_submitLocation() {

	query = $('zip').value;
	prefs.setQuery(query);
	
	Query_retrieve(query,null,Query_errorLoading);
}

function makeSelectBox(id,elements,eventListenerCallback) {
	var ele = document.getElementById(id);
	var option; var select;

	select = document.createElement('select');
	select.setAttribute("id",id);
	
	var optgroup = select;
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].optgroup) {
		  if (optgroup != select) {
		    select.appendChild(optgroup);
		  }
		  optgroup = document.createElement('optgroup');
		  optgroup.setAttribute("label",elements[i].name);
		  continue;
	  }
		  
		option = document.createElement('option');
		option.setAttribute('value',elements[i].value);
		if (elements[i].disabled) {option.setAttribute('disabled','disabled');}
		if (elements[i].selected) {option.setAttribute('selected','selected');}
		option.innerHTML = elements[i].name;
		optgroup.appendChild(option);
	}
	if (optgroup != select) {
	  select.appendChild(optgroup);
	}

	ele.parentNode.replaceChild(select,ele);

	ele = document.getElementById(id);
	ele.onchange = eventListenerCallback;
}

function Widget_drawerSetContent(id,evt,noAnimate) {
	var eles = ['photos','weekForecast'];
	var ele_id = document.getElementById(id);
	prefs.setDrawerState(id);
	
	if (id == "photos" && Photos_loaded == false) {
		Photos_retrieve(null, Photos_loadPhotos);
	}
		
	if (ele_id.style.visibility != "visible") {
		for(var i = 0; i < eles.length; i++) {
			if (id != eles[i]) {
				document.getElementById(eles[i]).style.opacity = 0;
				hide(eles[i]);
			}
		}
		
		if (!noAnimate) {showBottom(evt);}
		
		ele_id.style.visibility = 'visible';
	
		if (!noAnimate || Photos_loaded == true) {
			var fader = new Fader(ele_id,null,600);
			fader.fadeIn();
		} else {
			ele_id.style.opacity = 1;
		}
	} else {
		//trigger loading of photos if we haven't done it yet
		
		if (!noAnimate) {
			stretcher.stretch(evt);
		}
	}
}

function Widget_rightSetContent(id,noFade) {
  
	var eles = ['radar','conditions','wundercam'];
	var zIndicies = [0,-1,-2];
	var ele_id = document.getElementById(id);
	prefs.setRightContentState(id);

	if (ele_id.style.visibility != "visible") {
		for(var i = 0; i < eles.length; i++) {
			document.getElementById(eles[i]).style.opacity = 0;
			document.getElementById(eles[i] + "Tab").style.zIndex = zIndicies[i];
			document.getElementById(eles[i] + "Tab").style.backgroundImage = "url(Images/gui/tabs/" + eles[i] +"Tab.png)";
			hide(eles[i]);
		}
		
		ele_id.style.visibility = 'visible';
		document.getElementById(id + "Tab").style.zIndex = 1;
		document.getElementById(id + "Tab").style.backgroundImage = "url(Images/gui/tabs/" + id +"Tab_selected.png)";
		
		if (noFade != true) {
			var fader = new Fader(ele_id,null,600);
			fader.fadeIn();
		} else {
			ele_id.style.opacity = 1;
		}
	}
}

//change all CSS class styles to a different offset
function Widget_putColCSS(offset) {
 var cssRules;
 if (document.all) {
  cssRules = 'rules';
 }
 else if (document.getElementById) {
  cssRules = 'cssRules';
 }
  for (var R = 0; R < document.styleSheets[0][cssRules].length; R++) {
   if ((num = document.styleSheets[0][cssRules][R].selectorText.match(/^\.col(\d)$/)) != null) {
    document.styleSheets[0][cssRules][R].style.left = (COL_LEFT_VALS[num[1]] + offset) + "px";
   }
  }
}

/*
 * Used to change the current temp in the forecast when "both" is selected for units
 */
function Widget_changeHighSize(sizeInPxls) {
 var cssRules;
 if (document.all) {
  cssRules = 'rules';
 }
 else if (document.getElementById) {
  cssRules = 'cssRules';
 }	
 for (var R = 0; R < document.styleSheets[0][cssRules].length; R++) {
  if (document.styleSheets[0][cssRules][R].selectorText == '.high') {
   document.styleSheets[0][cssRules][R].style.fontSize = sizeInPxls + "px";
  }
 }
}

function Prefs_showOnly(id) {
	var elements = ["vagueLocationLabel","localWxStationLabel","vagueLocationSelect","localWxStationSelect","locationNotFound","connectionProblem"];
	if (typeof(id) == "string" || id == null)
		for(var i = 0; i < elements.length; i++) {
			elements[i] == id ? show(elements[i]) : hide(elements[i]);
		}
	else
	for(var i = 0; i < elements.length; i++) {
		hide(elements[i]);
		for (var j = 0; j < id.length; j++)
			if (elements[i] == id[j]) show(elements[i]); 
	}		
}

function Widget_changeWebcam(evt,manual_select) {
	var wunderimage = document.getElementById('wundercamImage');
	
	//manual_select is for the initial setting from the preferences
	if (manual_select != null) {
	  var selected = manual_select;
  }	else {
    var selected = $('wundercamSelect').selectedIndex;
  }
  prefs.setWebcam(selected);
  Widget_createWebcamImage(loc.webcams[selected]);

}

function Widget_setUpgradeDialog(latestVersion,url) {
  Widget_upgradeAlert = new Object();
  Widget_upgradeAlert.type = "REP";
  Widget_upgradeAlert.url = url;
  Widget_upgradeAlert.description = "This widget version is <b>"+Widget_VERSION+"</b>. The latest widget version is <b>" + latestVersion+"</b>";
  Widget_upgradeAlert.longSummary = "Click here or visit wunderground.com to upgrade!";

}

function Widget_createLogoLink() {
  addEvent($('logo'),'click',linkTo('http://www.wunderground.com'));
}

function Debug(){
	
	this.write = function(str) {
		var debugEle = document.getElementById('debug');
		if (debugEle) debugEle.innerHTML = debugEle.innerHTML + "<br/>" + str;
		if (typeof console != 'undefined' && typeof console.log != 'undefined') console.log(str);
	};
	this.error = function(error_str) {
		this.write(error_str);
	};
	this.trace = function(str) {
		this.write(str);
	};
	this.hide = function() {
    document.getElementById('debug_container').style.visibility = "hidden";  
	};
	this.show = function() {
    document.getElementById('debug_container').style.visibility = "visible";  
	};
}

addLoadEvent(Widget_createLogoLink);
addLoadEvent(loadButtons);
addLoadEvent(loadTimeouts);
addLoadEvent(Widget_setup);